package cn.iocoder.yudao.module.llm.service.prompttemplatestags;

import org.springframework.stereotype.Service;
import javax.annotation.Resource;
import org.springframework.validation.annotation.Validated;
import org.springframework.transaction.annotation.Transactional;

import java.util.*;
import cn.iocoder.yudao.module.llm.controller.admin.prompttemplatestags.vo.*;
import cn.iocoder.yudao.module.llm.dal.dataobject.prompttemplatestags.PromptTemplatesTagsDO;
import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.common.pojo.PageParam;
import cn.iocoder.yudao.framework.common.util.object.BeanUtils;

import cn.iocoder.yudao.module.llm.dal.mysql.prompttemplatestags.PromptTemplatesTagsMapper;

import static cn.iocoder.yudao.framework.common.exception.util.ServiceExceptionUtil.exception;
import static cn.iocoder.yudao.module.llm.enums.ErrorCodeConstants.*;

/**
 * Prompt 模板标签关系表，记录模板和标签之间的多对多关系 Service 实现类
 *
 * @author 华大大模型
 */
@Service
@Validated
public class PromptTemplatesTagsServiceImpl implements PromptTemplatesTagsService {

    @Resource
    private PromptTemplatesTagsMapper promptTemplatesTagsMapper;

    @Override
    public Long createPromptTemplatesTags(PromptTemplatesTagsSaveReqVO createReqVO) {
        // 插入
        PromptTemplatesTagsDO promptTemplatesTags = BeanUtils.toBean(createReqVO, PromptTemplatesTagsDO.class);
        promptTemplatesTagsMapper.insert(promptTemplatesTags);
        // 返回
        return promptTemplatesTags.getId();
    }

    @Override
    public void updatePromptTemplatesTags(PromptTemplatesTagsSaveReqVO updateReqVO) {
        // 校验存在
        validatePromptTemplatesTagsExists(updateReqVO.getId());
        // 更新
        PromptTemplatesTagsDO updateObj = BeanUtils.toBean(updateReqVO, PromptTemplatesTagsDO.class);
        promptTemplatesTagsMapper.updateById(updateObj);
    }

    @Override
    public void deletePromptTemplatesTags(Long id) {
        // 校验存在
        validatePromptTemplatesTagsExists(id);
        // 删除
        promptTemplatesTagsMapper.deleteById(id);
    }

    private void validatePromptTemplatesTagsExists(Long id) {
        if (promptTemplatesTagsMapper.selectById(id) == null) {
            throw exception(PROMPT_TEMPLATES_TAGS_NOT_EXISTS);
        }
    }

    @Override
    public PromptTemplatesTagsDO getPromptTemplatesTags(Long id) {
        return promptTemplatesTagsMapper.selectById(id);
    }

    @Override
    public PageResult<PromptTemplatesTagsDO> getPromptTemplatesTagsPage(PromptTemplatesTagsPageReqVO pageReqVO) {
        return promptTemplatesTagsMapper.selectPage(pageReqVO);
    }

}
